package pro.litvinovg.libreoffice.metadata;

import java.util.ArrayList;
import java.util.Iterator;

import org.json.JSONException;
import org.json.JSONObject;


import com.sun.star.text.XTextRange;

public class OutlineElement {

	private String name;
	private ArrayList<MetadataElement> metadata = null;

	public String getName() {
		return name;
	}

	private XTextRange textRange;
	private boolean hasMetadataStorage = false;
	private XTextRange annotationStart = null;
	private XTextRange annotationEnd = null;

	public OutlineElement(XTextRange textRange) {
		this.textRange = textRange;
		this.name = textRange.getString();
		this.metadata = new ArrayList<MetadataElement>();
		annotationStart = textRange.getStart();
	}
	public void setAnnotationAnchorEnd(XTextRange anchor) {
		this.annotationEnd = anchor;
	}
	
	public void readMetadata(String data) {
		try {
  		JSONObject json = new JSONObject(data);
  		Iterator<String> names = json.keys();
  		while (names.hasNext()) {
				String metaName = names.next();
				String metaValue = (String) json.get(metaName);
				metadata.add(new MetadataElement(metaName, metaValue));
			}
		} catch (JSONException e) {
			e.printStackTrace();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
public String metadataToString() {
    JSONObject json = new JSONObject();
    for (MetadataElement element : metadata) {
    	json.put(element.getName(), element.getValue());	
    }
		return json.toString();
	}
	


}
